#!/bin/sh

install_dir="/usr/local/cross"

binutils="binutils-2.21.1"
gcc="gcc-3.4.6"
gdb="gdb-7.3.1"

# Search GNU make. (GNU make installed as gmake on FreeBSD)
gmake=`which gmake`
if [ $gmake ]; then
    make=$gmake
else
    make=`which make`
    if [ ! $make ]; then
        echo GNU make not found. Install it.
        exit -1
    fi
    ver=`$make -q -v | head -1 | awk '{ print $1$2; }'`
    if [ ! $ver ]; then
        echo $make found, but not GNU make. Install it.
        exit -1
    fi
    if [ $ver != GNUMake ]; then
        echo $make found, but not GNU make version. Install it.
        exit -1
    fi
fi

# Need environment variable SHELL and PATH to build gcc.
if [ "$tool" = gcc ]; then
    SHELL=`which bash`
    export SHELL
    if [ ! $SHELL ]; then
        echo Cannot find GNU bash. Install it.
        exit -1
    fi
    PATH=$PATH:$install_dir/bin
    export PATH
fi
