#!/bin/sh

# major architectures.
targets="arm-elf h8300-elf i386-elf mips-elf powerpc-elf sh-elf"

# other architectures.
targets="$targets arc-elf avr-elf cris-elf fr30-elf frv-elf hppa-linux"
targets="$targets m32r-elf m6811-elf m68k-elf mcore-elf mips64-elf mmix-elf"
targets="$targets mn10300-elf pdp11-aout powerpc64-linux s390-linux sh64-elf"
targets="$targets sparc-elf strongarm-elf v850-elf x86_64-linux xscale-elf"
targets="$targets xstormy16-elf xtensa-elf"

# need patches to build cross binutils/gcc.
targets="$targets alpha-elf ia64-elf vax-netbsdelf"

# need obsolete option to build cross gcc.
targets_obsolete="i960-elf"

# gcc cross build failed.
##targets="$targets alpha-linux alpha-vms bfin-elf c4x-coff d10v-elf dlx-elf"
##targets="$targets hppa-elf i370-elf i370-linux i960-elf ip2k-elf iq2000-elf"
##targets="$targets m32c-elf microblaze-elf mn10200-elf msp430-elf mt-elf"
##targets="$targets or32-elf pdp11-dec-bsd pj-elf pjl-elf rs6000-aix"
##targets="$targets tic4x-coff tic54x-coff tic6x-elf"
##targets="$targets x86_64-elf x86_64-w64-mingw32 z80-coff z8k-coff"
##targets_obsolete="$targets_obsolete vax-linux"

tool="gcc"
operation="build"
. ../config.sh

# common options.
opt="--prefix=$install_dir"
opt="$opt --disable-nls --disable-threads --disable-shared"

# no newlib
opt="$opt --enable-languages=c"
# for newlib
#opt="$opt --with-newlib --enable-languages=c,c++"

# for current gcc (gcc-4.x.x)
# use LD_RUN_PATH instead of LD_LIBRARY_PATH to avoid runtime error.
# (if use LD_LIBRARY_PATH, fail to open shared libraries)
#LD_RUN_PATH=$install_dir/gmp/lib:$install_dir/mpfr/lib:$install_dir/mpc/lib
#export LD_RUN_PATH
#opt="$opt --with-gmp=$install_dir/gmp"
#opt="$opt --with-mpfr=$install_dir/mpfr"
#opt="$opt --with-mpc=$install_dir/mpc"
#opt="$opt --disable-libssp"
# unneed
##opt="$opt --without-headers"
##opt="$opt --disable-hosted-stdcxx"
##opt="$opt --with-gnu-as --with-gnu-ld --with-gnu-ar"

for target in $targets; do
    mkdir -p $target
    cd $target
    ../../../gnu/$gcc/configure --target=$target $opt
    $make
    cd ..
done

opt="$opt --enable-obsolete"

for target in $targets_obsolete; do
    mkdir -p $target
    cd $target
    ../../../gnu/$gcc/configure --target=$target $opt
    $make
    cd ..
done
