#!/bin/sh

# major architectures.
targets="arm-elf h8300-elf mips-elf powerpc-elf sh-elf"

# other architectures.
targets="$targets avr-elf cris-elf frv-elf m32r-elf m6811-elf"
targets="$targets mn10300-elf sh64-elf sparc-elf v850-elf"

# simulator only. (fail building gdb)
targets_simonly="mcore-elf"

tool="gdb"
operation="install"
. ../config.sh

for target in $targets; do
    cd $target
    $make install
    cd ..
done

subdirs="bfd opcodes libiberty sim"

for target in $targets_simonly; do
    cd $target
    for subdir in $subdirs; do
        cd $subdir
        $make install
        cd ..
    done
    cd ..
done
