/*
 * Use NetBSD/Linux system call.
 */

#define SYS_exit  1
#define SYS_read  3
#define SYS_write 4
#define SYS_open  5
#define SYS_close 6

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	mov	$_estack,%esp
	call	main
	push	$0
	call	__exit

	.globl	__exit
	.type	__exit, @function
__exit:
#ifdef __linux__
	push	%ebx
	push	%ecx
	push	%edx
	mov	16(%esp),%ebx
	mov	20(%esp),%ecx
	mov	24(%esp),%edx
#endif
	mov	$SYS_exit,%eax
	int	$0x80
#ifdef __linux__
	pop	%edx
	pop	%ecx
	pop	%ebx
#endif
	ret

	.globl	__read
	.type	__read, @function
__read:
#ifdef __linux__
	push	%ebx
	push	%ecx
	push	%edx
	mov	16(%esp),%ebx
	mov	20(%esp),%ecx
	mov	24(%esp),%edx
#endif
	mov	$SYS_read,%eax
	int	$0x80
#ifdef __linux__
	pop	%edx
	pop	%ecx
	pop	%ebx
#endif
	ret

	.globl	__write
	.type	__write, @function
__write:
#ifdef __linux__
	push	%ebx
	push	%ecx
	push	%edx
	mov	16(%esp),%ebx
	mov	20(%esp),%ecx
	mov	24(%esp),%edx
#endif
	mov	$SYS_write,%eax
	int	$0x80
#ifdef __linux__
	pop	%edx
	pop	%ecx
	pop	%ebx
#endif
	ret

	.globl	__open
	.type	__open, @function
__open:
#ifdef __linux__
	push	%ebx
	push	%ecx
	push	%edx
	mov	16(%esp),%ebx
	mov	20(%esp),%ecx
	mov	24(%esp),%edx
#endif
	mov	$SYS_open,%eax
	int	$0x80
#ifdef __linux__
	pop	%edx
	pop	%ecx
	pop	%ebx
#endif
	ret

	.globl	__close
	.type	__close, @function
__close:
#ifdef __linux__
	push	%ebx
	push	%ecx
	push	%edx
	mov	16(%esp),%ebx
	mov	20(%esp),%ecx
	mov	24(%esp),%edx
#endif
	mov	$SYS_close,%eax
	int	$0x80
#ifdef __linux__
	pop	%edx
	pop	%ecx
	pop	%ebx
#endif
	ret
