/*
 * Use reserved instruction.
 * See gdb/sim/mips/interp.c:signal_exception(),sim_monitor()
 * (ReservedInstruction)
 * Memory address is defined by K0BASE. (See gdb/sim/mips/interp.c)
 */

#define SYS_exit  17
#define SYS_open   6
#define SYS_read   7
#define SYS_write  8
#define SYS_close 10

#define RSVD_INSTRUCTION 0x00000005
#define RSVD(arg) ((((arg) << 1) << 6) | RSVD_INSTRUCTION)

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	lui	$sp, %hi(_estack)
	ori	$sp, $sp, %lo(_estack)
	jal	main
	nop
	li	$a0, 0
	/* fall through */

	.globl	__exit
	.type	__exit, @function
__exit:
	.int	RSVD(SYS_exit)
	jr	$ra

	.globl	__read
	.type	__read, @function
__read:
	.int	RSVD(SYS_read)
	jr	$ra

	.globl	__write
	.type	__write, @function
__write:
	.int	RSVD(SYS_write)
	jr	$ra

	.globl	__open
	.type	__open, @function
__open:
	.int	RSVD(SYS_open)
	jr	$ra

	.globl	__close
	.type	__close, @function
__close:
	.int	RSVD(SYS_close)
	jr	$ra
